<?php

namespace Drupal\light_category\Traits;

/**
 * Provides a 'Light Category trait'.
 */
trait LightCategoryTrait {


   /**
    * Return options array for select element
    *
    * @param string $str
    * @param $params
    * @return void
    */
   public static function getSelect( string $str, $params = NULL )
   {
      switch( $str ) {
         case 'view':
            return self::forEach( \Drupal::entityTypeManager()->getStorage('view')->loadMultiple() );
         break;
         case 'display':
            if( \Drupal\light_category\Plugin\Block\LightCategoryBlock::$ONLY_BLOCK ) {
               return self::getViewPluginBlock( \Drupal::entityTypeManager()->getStorage('view')->load( $params )->toArray()['display'] );
            } else {
               return self::forEach( \Drupal::entityTypeManager()->getStorage('view')->load( $params )->get('display') );
            }
         break;
      }
   }
   
   /**
    * Return options array for select element
    *
    * @param array $arr
    */
   public static function forEach( array $arr )
   {
      $selectList = [];
      foreach ( $arr as $key=>$value ) {
         $selectList[$key] =   $key;
      }
      return $selectList;
   }

   /**
    * Return options array for select element ( display view - block )
    *
    * @param array $arr
    */
    public static function getViewPluginBlock( array $arr )
    {
      $selectList = [];
      foreach ( $arr as $key=>$value ) {
         if ( $value['display_plugin'] != 'block' ) continue;
         $selectList[$key] =   $key;
      }
      return $selectList;
    }
}